commit a5356f12c4390eb046b19b1b547133ee9d05510a
Author: Vít Mazín <vit.mazin@seznam.cz>
Date:   Wed Mar 27 17:36:05 2019 +0100

    Added module for DOT converter
    
    Added module for DOT converter

diff --git a/.gitignore b/.gitignore
index 3a1589c..96e67cd 100644
--- a/.gitignore
+++ b/.gitignore
@@ -4,3 +4,7 @@
 sources/*/target/
 sources/*/logs/
 sources/imiger-core/src/main/webapp/node_modules/
+
+**/.DS_Store
+.DS_Store
+.DS_Store
diff --git a/sources/classes/production/imiger-dot-converter/META-INF/services/cz.zcu.kiv.imiger.spi.IModule b/sources/classes/production/imiger-dot-converter/META-INF/services/cz.zcu.kiv.imiger.spi.IModule
new file mode 100644
index 0000000..ec82154
--- /dev/null
+++ b/sources/classes/production/imiger-dot-converter/META-INF/services/cz.zcu.kiv.imiger.spi.IModule
@@ -0,0 +1 @@
+cz.zcu.kiv.imiger.plugin.dot.DOT
\ No newline at end of file
diff --git a/sources/classes/production/imiger-dot-converter/cz/zcu/kiv/imiger/plugin/dot/DOT.class b/sources/classes/production/imiger-dot-converter/cz/zcu/kiv/imiger/plugin/dot/DOT.class
new file mode 100644
index 0000000..dfac64b
Binary files /dev/null and b/sources/classes/production/imiger-dot-converter/cz/zcu/kiv/imiger/plugin/dot/DOT.class differ
diff --git a/sources/classes/production/imiger-dot-converter/log4j2.properties b/sources/classes/production/imiger-dot-converter/log4j2.properties
new file mode 100644
index 0000000..bf4c521
--- /dev/null
+++ b/sources/classes/production/imiger-dot-converter/log4j2.properties
@@ -0,0 +1,18 @@
+name=PropertiesConfig
+property.filename = logs
+appenders = console, file
+
+appender.console.type = Console
+appender.console.name = STDOUT
+appender.console.layout.type = PatternLayout
+appender.console.layout.pattern=%d{yy-MM-dd HH:mm:ss:SSS} %-6p [%c:%M:%L] - %m%n
+
+appender.file.type = File
+appender.file.name = LOGFILE
+appender.file.fileName=${filename}/propertieslogs.log
+appender.file.layout.type=PatternLayout
+appender.file.layout.pattern=%d{yy-MM-dd HH:mm:ss:SSS} %-6p [%c:%M:%L] - %m%n
+
+rootLogger.level = debug
+rootLogger.appenderRefs = stdout
+rootLogger.appenderRef.stdout.ref = STDOUT
\ No newline at end of file
diff --git a/sources/imiger-core/pom.xml b/sources/imiger-core/pom.xml
index 69dafa4..28316e5 100644
--- a/sources/imiger-core/pom.xml
+++ b/sources/imiger-core/pom.xml
@@ -92,6 +92,11 @@
             <artifactId>imiger-spade-converter</artifactId>
             <version>1.0-SNAPSHOT</version>
         </dependency>
+        <dependency>
+            <groupId>cz.zcu.kiv</groupId>
+            <artifactId>imiger-dot-converter</artifactId>
+            <version>1.0-SNAPSHOT</version>
+        </dependency>
 
         <dependency>
             <groupId>org.apache.logging.log4j</groupId>
diff --git a/sources/imiger-dot-converter/pom.xml b/sources/imiger-dot-converter/pom.xml
new file mode 100644
index 0000000..6428d1a
--- /dev/null
+++ b/sources/imiger-dot-converter/pom.xml
@@ -0,0 +1,93 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<project xmlns="http://maven.apache.org/POM/4.0.0"
+         xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
+         xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
+    <parent>
+        <artifactId>imiger</artifactId>
+        <groupId>cz.zcu.kiv</groupId>
+        <version>0.1.2-SNAPSHOT</version>
+        <relativePath>../pom.xml</relativePath>
+    </parent>
+    <modelVersion>4.0.0</modelVersion>
+
+    <artifactId>imiger-dot-converter</artifactId>
+    <version>1.0-SNAPSHOT</version>
+    <packaging>jar</packaging>
+
+    <properties>
+        <maven.compiler.source>1.8</maven.compiler.source>
+        <maven.compiler.target>1.8</maven.compiler.target>
+        <project.build.sourceEncoding>UTF-8</project.build.sourceEncoding>
+    </properties>
+
+    <build>
+        <plugins>
+            <plugin>
+                <groupId>org.apache.maven.plugins</groupId>
+                <artifactId>maven-assembly-plugin</artifactId>
+                <configuration>
+                    <descriptorRefs>
+                        <descriptorRef>jar-with-dependencies</descriptorRef>
+                    </descriptorRefs>
+                </configuration>
+                <executions>
+                    <execution>
+                        <id>make-assembly</id> <!-- this is used for inheritance merges -->
+                        <phase>package</phase> <!-- bind to the packaging phase -->
+                        <goals>
+                            <goal>single</goal>
+                        </goals>
+                    </execution>
+                </executions>
+            </plugin>
+        </plugins>
+    </build>
+
+    <dependencies>
+        <dependency>
+            <groupId>cz.zcu.kiv</groupId>
+            <artifactId>imiger-module</artifactId>
+            <version>0.1.2-SNAPSHOT</version>
+        </dependency>
+
+        <dependency>
+            <groupId>com.paypal.digraph</groupId>
+            <artifactId>digraph-parser</artifactId>
+            <version>1.0</version>
+        </dependency>
+
+        <!-- Lib for JSON handling -->
+        <dependency>
+            <groupId>com.google.code.gson</groupId>
+            <artifactId>gson</artifactId>
+            <version>2.8.5</version>
+        </dependency>
+
+        <!-- Lib for loading file -->
+        <dependency>
+            <groupId>commons-io</groupId>
+            <artifactId>commons-io</artifactId>
+            <version>2.6</version>
+        </dependency>
+
+        <!-- Libs for Logging -->
+        <dependency>
+            <groupId>org.apache.logging.log4j</groupId>
+            <artifactId>log4j-api</artifactId>
+            <version>2.11.1</version>
+        </dependency>
+        <dependency>
+            <groupId>org.apache.logging.log4j</groupId>
+            <artifactId>log4j-core</artifactId>
+            <version>2.11.1</version>
+        </dependency>
+
+        <!-- Libs for Unit testing -->
+        <dependency>
+            <groupId>org.junit.jupiter</groupId>
+            <artifactId>junit-jupiter-api</artifactId>
+            <version>5.3.2</version>
+            <scope>test</scope>
+        </dependency>
+    </dependencies>
+</project>
\ No newline at end of file
diff --git a/sources/imiger-dot-converter/src/main/java/cz/zcu/kiv/imiger/plugin/dot/DOT.java b/sources/imiger-dot-converter/src/main/java/cz/zcu/kiv/imiger/plugin/dot/DOT.java
new file mode 100644
index 0000000..27842c0
--- /dev/null
+++ b/sources/imiger-dot-converter/src/main/java/cz/zcu/kiv/imiger/plugin/dot/DOT.java
@@ -0,0 +1,15 @@
+package cz.zcu.kiv.imiger.plugin.dot;
+
+import cz.zcu.kiv.imiger.spi.IModule;
+
+public class DOT implements IModule {
+    @Override
+    public String getModuleName() {
+        return "DOT file";
+    }
+
+    @Override
+    public String getRawJson(String stringToConvert) {
+        return null;
+    }
+}
diff --git a/sources/imiger-dot-converter/src/main/resources/META-INF/services/cz.zcu.kiv.imiger.spi.IModule b/sources/imiger-dot-converter/src/main/resources/META-INF/services/cz.zcu.kiv.imiger.spi.IModule
new file mode 100644
index 0000000..ec82154
--- /dev/null
+++ b/sources/imiger-dot-converter/src/main/resources/META-INF/services/cz.zcu.kiv.imiger.spi.IModule
@@ -0,0 +1 @@
+cz.zcu.kiv.imiger.plugin.dot.DOT
\ No newline at end of file
diff --git a/sources/imiger-dot-converter/src/main/resources/log4j2.properties b/sources/imiger-dot-converter/src/main/resources/log4j2.properties
new file mode 100644
index 0000000..bf4c521
--- /dev/null
+++ b/sources/imiger-dot-converter/src/main/resources/log4j2.properties
@@ -0,0 +1,18 @@
+name=PropertiesConfig
+property.filename = logs
+appenders = console, file
+
+appender.console.type = Console
+appender.console.name = STDOUT
+appender.console.layout.type = PatternLayout
+appender.console.layout.pattern=%d{yy-MM-dd HH:mm:ss:SSS} %-6p [%c:%M:%L] - %m%n
+
+appender.file.type = File
+appender.file.name = LOGFILE
+appender.file.fileName=${filename}/propertieslogs.log
+appender.file.layout.type=PatternLayout
+appender.file.layout.pattern=%d{yy-MM-dd HH:mm:ss:SSS} %-6p [%c:%M:%L] - %m%n
+
+rootLogger.level = debug
+rootLogger.appenderRefs = stdout
+rootLogger.appenderRef.stdout.ref = STDOUT
\ No newline at end of file
diff --git a/sources/pom.xml b/sources/pom.xml
index 1abf8ad..f310798 100644
--- a/sources/pom.xml
+++ b/sources/pom.xml
@@ -16,6 +16,7 @@
         <module>imiger-core</module>
         <module>imiger-module</module>
         <module>imiger-spade-converter</module>
+        <module>imiger-dot-converter</module>
     </modules>
 
     <properties>